jQuery(document).ready(function($) {
    // if the current post type is not allowed, do not enable the text-to-speech functionality
    if (!HighlightTTSSettings.post_types.includes(HighlightTTSSettings.current_post_type)) {
        return;
    }

    var ttsIconId = 'highlight-tts-icon';
    var iconUrl = HighlightTTSSettings.icon || plugin_dir_url(__FILE__) + 'assets/mic.png';// Use the default image if no icon URL is set in the settings
    var iconSize = parseInt(HighlightTTSSettings.icon_size, 10) || 30; // Use 30px as default icon size if not set in the settings
    
    var voice = 'UK English ' + (HighlightTTSSettings.voice === 'female' ? 'Female' : 'Male');
    
    $(document).mouseup(function(event) {
        var highlightedText = window.getSelection().toString().trim();
        
        if (highlightedText !== '') {
            if ($('#' + ttsIconId).length === 0) {
                var ttsIcon = $('<img>', {
                    src: iconUrl,
                    alt: 'Text-to-Speech',
                    id: ttsIconId
                });
                
                ttsIcon.css({
                    position: 'absolute',
                    top: event.pageY - 30,
                    left: event.pageX - 15,
                    cursor: 'pointer',
                    zIndex: 9999,
                    width: iconSize + 'px', // Set icon width based on the settings
                    height: iconSize + 'px' // Set icon height based on the settings
                });
                
                ttsIcon.click(function() {
                    responsiveVoice.speak(highlightedText, voice);
                    ttsIcon.remove();
                });
                
                $('body').append(ttsIcon);
            } else {
                $('#' + ttsIconId).css({
                    top: event.pageY - 30,
                    left: event.pageX - 15
                });
            }
        } else {
            $('#' + ttsIconId).remove();
        }
    });
});
